POSTGRES95(UNIX)

NAME
postgres — the Postgres backend server

SYNOPSIS
postgres [-B n_buffers] [-E ] [-P filedes] [-Q ]
[-d debug_level] [-o output_file] [-s ] [dbname]

DESCRIPTION
The Postgres backend server can be executed directly from the user shell. This should be done only while debugging by the DBA, and should not be done while other Postgres backends are being managed by a postmaster on this set of databases.

The optional argument dbname specifies the name of the database to be accessed. Dbname defaults to the value of the USER environment variable.

The postgres server understands the following command-line options:

-B n_buffers
    If the backend is running under the postmaster, n_buffers is the number of shared-memory buffers that the postmaster has allocated for the backend server processes that it starts. If the backend is running standalone, this specifies the number of buffers to allocate. This value defaults to 64.

-E  Echo all queries.

-P filedes
    filedes specifies the file descriptor that corresponds to the socket (port) on which to communicate to the frontend process. This option is not useful for interactive use.

-Q  Specifies “quiet” mode.

-d debug_level
    Turns on debugging at the numeric level debug_level. Turning on debugging will cause query parse trees and query plans to be displayed.

-o output_file
    Sends all debugging and error output to output_file. If the backend is running under the postmaster, error messages are still sent to the frontend process as well as to output_file, but debugging output is sent to the controlling tty of the postmaster (since only one file descriptor can be sent to an actual file).

-s  Print time information and other statistics at the end of each query. This is useful for benchmarking or for use in tuning the number of buffers.

DEPRECATED COMMAND OPTIONS
There are several other options that may be specified, used mainly for debugging purposes. These are listed here only for the use by Postgres system developers. Use of any of these options is highly discouraged. Furthermore, any of these options may disappear or change at any time.

-An|r|b|Qn|Xn

    This option generates a tremendous amount of output.

-L  Turns off the locking system.

-N  Disables use of newline as a query delimiter.

-S  Indicates that the transaction system can run with the assumption of stable main memory, thereby avoiding the necessary flushing of data and log pages to disk at the end of each transaction system. This is only used for performance comparisons for stable vs. non-stable storage. Do not use this in other cases, as recovery after a system crash may be impossible when this option is specified in the absence of stable main memory.

-b  Enables generation of bushy query plan trees (as opposed to left-deep query plans trees). These query plans are not intended for actual execution; in addition, this flag often causes Postgres to run out of memory.

-f  Forbids the use of particular scan and join methods: s and i disable sequential and index scans respectively, while n, m and h disable nested-loop, merge and hash joins respectively. This is another feature that may not necessarily produce executable plans.

-p  Indicates to the backend server that it has been started by a postmaster and make different assumptions about buffer pool management, file descriptors, etc.

-tpa[rser]|pl[anner]|e[xecutor]
    Print timing statistics for each query relating to each of the major system modules. This option cannot be used with -s.

SEE ALSO
ipcclean(1), psql(1), postmaster(1).

DIAGNOSTICS
Of the nigh-infinite number of error messages you may see when you execute the backend server directly, the most common will probably be:

semget: No space left on device
    If you see this message, you should run the ipcclean command. After doing this, try starting postgres again. If this still doesn't work, you probably need to configure your kernel for shared memory and semaphores as described in the installation notes.